from datetime import datetime
from time import sleep
# from decimal import Decimal, getcontext
from selenium import webdriver
from selenium.webdriver import ChromeOptions
from selenium.webdriver.common.keys import Keys
from selenium.common.exceptions import NoSuchElementException, ElementClickInterceptedException
from selenium.common.exceptions import StaleElementReferenceException, TimeoutException
import Mailer
import selenium.webdriver.support.ui as sui
import os
import logging

no_element_exceptions = (NoSuchElementException,
                         ElementClickInterceptedException)
all_element_exceptions = (NoSuchElementException,
                          ElementClickInterceptedException,
                          StaleElementReferenceException,
                          ValueError)
safety_timeout_exc = (StaleElementReferenceException, TimeoutException)
logging.basicConfig(filename='extrase/bt_sent_statements',
                    format='%(asctime)s %(message)s', datefmt='%Y-%m-%d', level=logging.INFO)

letter = Mailer.mailer_details(mail_to=Mailer.TO, mail_from=Mailer.FR_ADDR, mail_subj=Mailer.SUBJ)
# getcontext().prec = 3

chrome_options = ChromeOptions()
chrome_options.add_argument('--disable-infobars')
chrome_options.add_argument('--disable-dev-shm-usage')
chrome_options.add_argument('--no-sandbox')
chrome_options.add_argument('--disable-gpu')
chrome_options.add_argument('user-data-dir=_bt_')
# chrome_options.add_argument('--incognito')
browser = webdriver.Chrome(chrome_options=chrome_options)

brd_data = {'brd_url': 'https://www.brdoffice.ro/smartoffice/_mcologon?...OASLogon%2ELanguage=RO',
            'brd_el_us': 'OASLogon.User',
            'brd_el_pw': 'OASLogon.PIN',
            'brd_login': '31300126',
            'brd_refresh': 'pmi_1_123',
            'd_name': 'BRD'}

bt_data = {'bt_url': 'https://ib.btrl.ro/BT24/bfo/channel/web/loginframe.jsp?locale=RO',
           'bt_el_us': '$$LoginId$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest',
           'bt_el_pw': '$$AuthToken$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest',
           'bt_login': 'N63584PA',
           'bt_refresh': 'balancerefresh_ron_link',
           'd_name': 'BT'}

uni_data = {'uni_url': 'https://ro.unicreditbanking.net/disp?lang=ro&embedcontentname=BusinessNet',
            'uni_el_us': 'login_input mandatory_field',
            'uni_el_pw': '1259368392',
            'uni_login': '1138725MZK',
            'uni_refresh': ':w.label',
            'd_name': 'UNI'}


def bank_load(browser, nr_tabs):
    browser.get('https://duckduckgo.com/?q=python&t=hf&ia=about')
    print('...wait to load %s tabs' % (nr_tabs + 1))
    first_result = sui.WebDriverWait(browser, 15).until(lambda browser: browser.find_element_by_class_name('body--serp'))
    first_link = first_result.find_element_by_tag_name('a')
    main_window = browser.current_window_handle
    browser.switch_to.window(main_window)
    i = 0
    while i < nr_tabs:
        first_link.send_keys(Keys.CONTROL + Keys.RETURN)
        i += 1
        sleep(1)
    browser.switch_to.window(browser.window_handles[0])
    sleep(2)


def bank_login(browser, tab, data_dict, url, logelem, login, passelem, passw=None):
    browser.switch_to.window(browser.window_handles[tab])
    print('...switching to tab %s' % (tab + 1))
    browser.get(data_dict[url])
    print('...bank url is %s' % (data_dict[url]))
    sleep(1)
    if data_dict == bt_data:
        bt_iframe = browser.find_elements_by_tag_name('iframe')[0]
        browser.switch_to.frame(bt_iframe)
        user = browser.find_element_by_id(data_dict[logelem])
        user.send_keys(data_dict[login])
        passv = browser.find_element_by_id(data_dict[passelem])
        passv.send_keys(input('...token pass here'))
        passv.send_keys(Keys.RETURN)
        # browser.switch_to.default_content()
        # bt_iframe_x = browser.find_elements_by_tag_name('iframe')[0]
        # browser.switch_to.frame(bt_iframe_x)
#         _client = sui.WebDriverWait(browser, 10).until(lambda browser: browser.find_element_by_xpath('//*[@id="button2"]'))
#         _client.click()
    elif data_dict == uni_data:
        els = browser.find_elements_by_xpath('//*[@id]')
        for i in els:
            if i.get_attribute('class') == data_dict[logelem]:
                e = i.get_attribute('id')
                user = browser.find_element_by_id(e)
    elif data_dict == brd_data:
        user = browser.find_element_by_id(data_dict[logelem])
        try:
            close_ad = browser.find_element_by_id('splash-45555-close-button')
            close_ad.click()
        except no_element_exceptions as exc:
            print(str(exc))
        passv = browser.find_element_by_id(data_dict[passelem])
    if data_dict == uni_data:
        user.send_keys(data_dict[login])
        user.send_keys(Keys.RETURN)
        sleep(5)
        els = browser.find_elements_by_xpath('//*[@id]')
        for i in els:
            if i.get_attribute('class') == data_dict[logelem]:
                e = i.get_attribute('id')
                passv = browser.find_element_by_id(e)
        passv.send_keys(input('...token pass here'))
        passv.send_keys(Keys.RETURN)
        #         sleep(5)
    elif data_dict == brd_data:
        user = browser.find_element_by_id(data_dict[logelem])
        try:
            close_ad = browser.find_element_by_id('splash-45555-close-button')
            close_ad.click()
        except no_element_exceptions as exc:
            print(str(exc))
        user.send_keys(data_dict[login])
        passw = input('...token pass here')
        passv.send_keys(passw)
        passv.send_keys(Keys.RETURN)
    if data_dict == brd_data:
        rap = sui.WebDriverWait(browser, 15).until(lambda browser: browser.find_element_by_id('pmi_1'))
        rap.click()
    sleep(5)


def extras_dl(browser, data_dict):
    print('verifying statements')
    if data_dict == brd_data:
        with open('extrase/br_sent_statements') as log_file:
            if len(os.listdir('extrase')) < 1:
                print('folder is empty')
            else:
                # for att in filter(lambda files: files.endswith('.pdf'), os.listdir('extrase')):
                pass
            lines = log_file.readlines()
            if len(lines) < 1:
                print('file is empty')
            else:
                print('files were found', lines[-1][:10])
            if datetime.now().hour > 17 and lines[-1][:10] != str(datetime.now().date()):
                extr = sui.WebDriverWait(browser, 10).until(lambda browser: browser.find_element_by_xpath('//*[@id="idListUngrouped"]/tbody/tr[4]/td[1]/a'))
                extr.click()
                sleep(1)
                extr_dl = browser.find_element_by_id('linkpdf')
                extr_dl.click()
                sleep(0.5)
                print('statement downloaded')
                logging.info('date logged')
            else:
                print('skipping statement')
    elif data_dict == uni_data:
        with open('extrase/un_sent_statements') as log_file:
            if len(os.listdir('extrase')) < 1:
                print('folder is empty')
            else:
                # for att in filter(lambda files: files.endswith('.pdf'), os.listdir('extrase')):
                pass
            lines = log_file.readlines()
            if len(lines) < 1:
                print('file is empty')
            else:
                print('files were found', lines[-1][:10])
            if datetime.now().hour > 17 and lines[-1][:10] != str(datetime.now().date()):
                els = browser.find_elements_by_xpath('//*[@id]')
                for extr in els:
                    if extr.get_attribute('class') == 'pActionIcon headpdf':
                        extr_id = extr.get_attribute('id')
                        extr_dl = sui.WebDriverWait(browser, 10).until(lambda browser: browser.find_element_by_id(extr_id))
                        extr_dl.click()
                        sleep(0.5)
                print('statement downloaded')
                logging.info('date logged')
            else:
                print('skipping statement')
    elif data_dict == bt_data:
        sleep(1)
        with open('extrase/bt_sent_statements') as log_file:
            if len(os.listdir('extrase')) < 1:
                print('folder is empty')
            else:
                # for att in filter(lambda files: files.endswith('.pdf'), os.listdir('extrase')):
                pass
            lines = log_file.readlines()
            if len(lines) < 1:
                print('file is empty')
            else:
                print('files were found', lines[-1][:10])
            if datetime.now().hour > 17 and lines[-1][:10] != str(datetime.now().date()):
                sleep(2)
                extr = sui.WebDriverWait(browser, 5).until(lambda browser: browser.find_elements_by_id('26603_link')[0])  # browser.find_element_by_id('26603_link')
                extr.click()
                sleep(1)
                browser.switch_to.default_content()
                page_iframe = browser.find_elements_by_tag_name('iframe')[1]
                browser.switch_to.frame(page_iframe)
                sleep(0.5)
                extr_account = sui.WebDriverWait(browser, 15).until(lambda browser: browser.find_elements_by_class_name('linkLabelVisited')[1])
                sleep(0.5)
                extr_account.click()
                sleep(10)
                # extr_search = sui.WebDriverWait(browser, 10).until(lambda browser: browser.find_element_by_xpath('//*[@id="searchButton"]/span[2]')) # class: button_general_center xpath: //*[@id="searchButton"]/span[2]
                # extr_search.click() # //*[@id="download_2"]/span //*[@id="download_1"]/span
                # sleep(2)
                extr_pdf = sui.WebDriverWait(browser, 15).until(lambda browser: browser.find_element_by_xpath('.//*[@id="export2"]'))  # './/*[@id="download_1"]/span'
                extr_pdf.click()
                sleep(0.5)
                extr_dl = sui.WebDriverWait(browser, 15).until(lambda browser: browser.find_element_by_xpath('//*[@id="export"]/span[2]'))
                extr_dl.click()
                sleep(1)
                browser.switch_to.default_content()
                _home = browser.find_elements_by_class_name('image_close')[1]  # //*[@id="page1542644222340693_close_img"]
                _home.click()
                sleep(0.5)
                print('statement downloaded')
                logging.info('date logged')
            else:
                print('skipping statement')
    sleep(2)


def refresh(browser, data_dict, to_refresh):
    c = 1
    err = 1
    if data_dict == bt_data:
        bt_iframe2 = browser.find_elements_by_tag_name('iframe')[0]
        browser.switch_to.frame(bt_iframe2)
        # _user = sui.WebDriverWait(browser, 10).until(lambda browser: browser.find_element_by_xpath('//*[@id="button2"]/span')) # browser.find_element_by_xpath('//*[@id="button2"]/span')
        # _user.click()
        # sleep(3)
        # browser.switch_to.default_content()
        # bt_iframe2 = browser.find_elements_by_tag_name('iframe')[0]
        # browser.switch_to.frame(bt_iframe2)
        bal = sui.WebDriverWait(browser, 10).until(lambda browser: browser.find_element_by_id(data_dict['refresh']))
        print(bal.get_attribute('id'))
    elif data_dict == uni_data:
        bal = browser.find_element_by_id(data_dict[to_refresh])
        print(bal.get_attribute('id'))
    elif data_dict == brd_data:
        bal = browser.find_element_by_id(data_dict[to_refresh])
        print(bal.get_attribute('id'))
    while True:
        s_cont = []
        try:
            t = 210
            sleep(3)
            print(data_dict['d_name'])
            if data_dict == brd_data:
                sold = browser.find_element_by_xpath('//*[@id="idListUngrouped"]/tbody/tr[4]/td[6]')
                s_cont.append(sold.text)
                try:
                    extras_dl(browser, data_dict)
                    bal.click()
                    sleep(2)
                except all_element_exceptions:
                    print('...skipping')
            elif data_dict == bt_data:
                sold = browser.find_element_by_xpath('//*[@id="ronBalanceOnline"]')
                s_cont.append(sold.text)
                try:
                    extras_dl(browser, data_dict)
                    bal.click()
                    sleep(2)
                except all_element_exceptions:
                    print('...skipping')
            elif data_dict == uni_data:
                all_els = browser.find_elements_by_xpath('//*[@id]')
                my_str = ''.join(i.text for e, i in enumerate(all_els) if e == 0)
                if ''.join(i for n, i in enumerate(my_str.split()) if n == 92) == '1138725001':
                    if ''.join(i for n, i in enumerate(my_str.split()) if n == 89) == '':
                        sold = ''.join(i for n, i in enumerate(my_str.split()) if n == 86)
                    elif ''.join(i for n, i in enumerate(my_str.split()) if n == 86) == '':
                        sold = ''.join(i for n, i in enumerate(my_str.split()) if n == 87)
                    elif ''.join(i for n, i in enumerate(my_str.split()) if n == 87) == '':
                        sold = ''.join(i for n, i in enumerate(my_str.split()) if n == 88)
                    else:
                        sold = ''.join(i for n, i in enumerate(my_str.split()) if n == 89)
                else:
                    sold = ''.join(i for n, i in enumerate(my_str.split()) if n == 92)
                s_cont.append(sold)
                try:
                    extras_dl(browser, data_dict)
                    bal.click()
                    sleep(2)
                except all_element_exceptions:
                    print('...skipping')
            if isinstance(Mailer.dig_it(s_cont[0]), float):
                print('...prev balance: {}'.format(Mailer.dig_it(s_cont[0])))
            while t >= 0:
                mins, secs = divmod(t, 60)
                timeformat = '{:02d}:{:02d}'.format(mins, secs)
                print('...clicking in', timeformat, end='\r')
                sleep(1)
                t -= 1
            print('')
            print('...now clicking')
            bal.click()
            sleep(3)
            if data_dict == brd_data:
                sold1 = browser.find_element_by_xpath('//*[@id="idListUngrouped"]/tbody/tr[4]/td[6]')
            elif data_dict == bt_data:
                sold1 = browser.find_element_by_xpath('//*[@id="ronBalanceOnline"]')
            elif data_dict == uni_data:
                all_els = browser.find_elements_by_xpath('//*[@id]')
                my_str = ''.join(i.text for e, i in enumerate(all_els) if e == 0)
                if ''.join(i for n, i in enumerate(my_str.split()) if n == 92) == '1138725001':
                    if ''.join(i for n, i in enumerate(my_str.split()) if n == 89) == '':
                        sold1 = ''.join(i for n, i in enumerate(my_str.split()) if n == 86)
                    elif ''.join(i for n, i in enumerate(my_str.split()) if n == 86) == '':
                        sold1 = ''.join(i for n, i in enumerate(my_str.split()) if n == 87)
                    elif ''.join(i for n, i in enumerate(my_str.split()) if n == 87) == '':
                        sold1 = ''.join(i for n, i in enumerate(my_str.split()) if n == 88)
                    else:
                        sold1 = ''.join(i for n, i in enumerate(my_str.split()) if n == 89)
                else:
                    sold1 = ''.join(i for n, i in enumerate(my_str.split()) if n == 92)
            print('')
            try:
                sleep(0.5)
                if isinstance(Mailer.dig_it(sold1.text), float):
                    print('...new balance: {0}'.format(Mailer.dig_it(sold1.text)))
            except ValueError:
                sleep(1)
                try:
                    if isinstance(Mailer.dig_it(sold1), float):
                        print('...new balance2: {0}'.format(Mailer.dig_it(sold1)))
                except TypeError:
                    pass
            try:
                print('1`st try')
                if Mailer.dig_it(sold1.text) - Mailer.dig_it(s_cont[0]) != 0:
                    if sold1 == '':
                        print('reinitiate sold')
                    else:
                        if isinstance(Mailer.dig_it(sold1.text), float):
                            letter._subject = data_dict['d_name'] + ' ' + Mailer.SUBJ + \
                                ' {0:2d}:{1:2d}:{2:2d}'.format(datetime.now().time().hour, datetime.now().time().minute, datetime.now().time().second)
                            letter.add_to_text_body(
                                'You`r receiving this mail because of a bank account event.\n\n \
                                Bank name: {0}\nTransaction details: {1}\n\nMozaik Consulting\nfinancial department\n\n{2}'.format(
                                    data_dict['d_name'], round(Mailer.dig_it(sold1.text) - Mailer.dig_it(s_cont[0]), 2), datetime.now().time()))
                            letter.send(Mailer.S_NAME, Mailer.P_NUM, Mailer.LOG_U, Mailer.PAS, Mailer.SEC)
                            print('notification sent, diff: {0}'.format(Mailer.dig_it(sold1.text) - Mailer.dig_it(s_cont[0])))
                else:
                    if isinstance(Mailer.dig_it(sold1.text), float):
                        print('...balance not changed, diff: {0}'.format(Mailer.dig_it(sold1.text) - Mailer.dig_it(s_cont[0])))
            except ValueError:
                print('2`nd try')
                try:
                    if Mailer.dig_it(sold1) - Mailer.dig_it(s_cont[0]) != 0:
                        if isinstance(Mailer.dig_it(sold1), float):
                            letter._subject = data_dict['d_name'] + ' ' + Mailer.SUBJ + \
                                ' {0:2d}:{1:2d}:{2:2d}'.format(datetime.now().time().hour, datetime.now().time().minute, datetime.now().time().second)
                            letter.add_to_text_body(
                                'You`r receiving this mail because of a bank account event.\n\n \
                                Bank name: {0}\nTransaction details: {1}\n\nMozaik Consulting\nfinancial department\n\n{2}'.format(
                                    data_dict['d_name'], round(Mailer.dig_it(sold1) - Mailer.dig_it(s_cont[0]), 2), datetime.now().time()))
                            letter.send(Mailer.S_NAME, Mailer.P_NUM, Mailer.LOG_U, Mailer.PAS, Mailer.SEC)
                            print('...notification sent, diff: {0}'.format(Mailer.dig_it(sold1) - Mailer.dig_it(s_cont[0])))
                    else:
                        if isinstance(Mailer.dig_it(sold1), float):
                            print('...balance not changed, diff: {0}'.format(Mailer.dig_it(sold1) - Mailer.dig_it(s_cont[0])))
                except TypeError:
                    pass
            print('...clicked {0} times'.format(c))
            c += 1
        except all_element_exceptions:
            print('...element lost %s times, waiting to return' % (err))
            if data_dict == brd_data:
                try:
                    bal = sui.WebDriverWait(browser, 10).until(lambda browser: browser.find_element_by_id(data_dict[to_refresh]))
                except safety_timeout_exc:
                    bank_login(browser, 0, brd_data, 'brd_url', 'brd_el_us', 'brd_login', 'brd_el_pw')
                # bal.click()  # browser.find_element_by_id(data_dict[to_refresh])
            elif data_dict == bt_data:
                try:
                    bt_iframe = sui.WebDriverWait(browser, 10).until(lambda browser: browser.find_elements_by_tag_name('iframe')[0])  # browser.find_elements_by_tag_name('iframe')[0]
                    browser.switch_to.frame(bt_iframe)
                    bal = sui.WebDriverWait(browser, 10).until(lambda browser: browser.find_element_by_id(data_dict[to_refresh]))
                except:
                    try:
                        bal = sui.WebDriverWait(browser, 10).until(lambda browser: browser.find_element_by_id(data_dict[to_refresh]))
                    except safety_timeout_exc:
                        bank_login(browser, 0, bt_data, 'bt_url', 'bt_el_us', 'bt_login', 'bt_el_pw')
            elif data_dict == uni_data:
                bal = sui.WebDriverWait(browser, 240).until(lambda browser: browser.find_element_by_id(data_dict[to_refresh]))  # browser.find_element_by_id(data_dict[to_refresh])
            # print(bal.get_attribute('id'))
            err += 1


bank_load(browser, 0)
bank_login(browser, 0, bt_data, 'bt_url', 'bt_el_us', 'bt_login', 'bt_el_pw')
# bank_login(driver, 0, brd_data, 'brd_url', 'brd_el_us', 'brd_login', 'brd_el_pw')
# bank_login(driver, 0, uni_data, 'uni_url', 'uni_el_us', 'uni_login', 'uni_el_pw')
refresh(browser, bt_data, 'bt_refresh')
# refresh(driver, brd_data, 'brd_refresh')
# refresh(driver, uni_data, 'uni_refresh')
