'''
Created on Sep 20, 2019

@author: levente.marton
'''

from time import sleep
from collections import deque
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.support import ui as sui
from selenium.common.exceptions import NoSuchElementException, ElementClickInterceptedException
from selenium.common.exceptions import StaleElementReferenceException, TimeoutException, WebDriverException
from datetime import datetime
from ._remotebank import RemoteBank
from . import mailer
import os
import logging

no_element_exceptions = (NoSuchElementException,
                         ElementClickInterceptedException,
                         WebDriverException)
all_element_exceptions = (NoSuchElementException,
                          ElementClickInterceptedException,
                          StaleElementReferenceException,
                          ValueError, WebDriverException)
safety_timeout_exc = (StaleElementReferenceException, TimeoutException)

letter = mailer.mailer_details(mail_to=mailer.TO, mail_from=mailer.FR_ADDR, mail_subj=mailer.SUBJ)

dict_data = {'uni_url': 'https://ro.unicreditbanking.net/disp?lang=ro&embedcontentname=BusinessNet',
            'uni_el_us': 'login_input mandatory_field',
            'uni_el_pw': '1259368392',
            'uni_login': '1138725MZK',
            'uni_refresh': ':w.label',
            'd_name': 'UNI'}

class Bank(RemoteBank):
    '''
    classdocs
    '''
    def __init__(self):
        '''
        Constructor
        '''
        # self.dict_data = bank_details
        super().__init__()

    def bank_login(self):
        els = self.find_elements_by_xpath('//*[@id]')
        for i in els:
            if i.get_attribute('class') == dict_data['uni_el_us']:
                e = i.get_attribute('id')
                user = self.find_element_by_id(e)
        user.send_keys(dict_data['uni_login'])
        user.send_keys(Keys.RETURN); sleep(5)
        els = self.find_elements_by_xpath('//*[@id]')
        for i in els:
            if i.get_attribute('class') == dict_data['uni_el_us']:
                e = i.get_attribute('id')
                passv = self.find_element_by_id(e)
        passv.send_keys(input('...token pass here'))
        passv.send_keys(Keys.RETURN)

    def _extras_dl(self):
        print('verifying statements'); sleep(1)
        with open(self.statement_folder) as log_file:
            if len(os.listdir('extrase')) < 1:
                print('folder is empty')
            else:
                # for att in filter(lambda files: files.endswith('.pdf'), os.listdir('extrase')):
                pass
            lines = log_file.readlines()
            if len(lines) < 1:
                print('file is empty')
            else:
                print('files were found', lines[-1][:10])
            if datetime.now().hour > 17 and lines[-1][:10] != str(datetime.now().date()):
                els = self.find_elements_by_xpath('//*[@id]')
                for extr in els:
                    if extr.get_attribute('class') == 'pActionIcon headpdf':
                        extr_id = extr.get_attribute('id')
                        extr_dl = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_element_by_id(extr_id))
                        extr_dl.click()
                        sleep(0.5)
                print('statement downloaded')
                logging.info('date logged')
            else:
                print('skipping statement'); sleep(2)

    def refresh(self):
        c = 1
        err = 1
        bal = self.find_element_by_id(dict_data['uni_refresh'])
        print(bal.get_attribute('id'))
        logback = False
        while True:
            s_cont = []
            try:
                t = 210; sleep(3)
                print(dict_data['d_name'])
                all_els = self.find_elements_by_xpath('//*[@id]')
                my_str = ''.join(i.text for e, i in enumerate(all_els) if e == 0)
                if ''.join(i for n, i in enumerate(my_str.split()) if n == 92) == '1138725001':
                    if ''.join(i for n, i in enumerate(my_str.split()) if n == 89) == '':
                        sold = ''.join(i for n, i in enumerate(my_str.split()) if n == 86)
                    elif ''.join(i for n, i in enumerate(my_str.split()) if n == 86) == '':
                        sold = ''.join(i for n, i in enumerate(my_str.split()) if n == 87)
                    elif ''.join(i for n, i in enumerate(my_str.split()) if n == 87) == '':
                        sold = ''.join(i for n, i in enumerate(my_str.split()) if n == 88)
                    else:
                        sold = ''.join(i for n, i in enumerate(my_str.split()) if n == 89)
                else:
                    sold = ''.join(i for n, i in enumerate(my_str.split()) if n == 92)
                if logback is False:
                    s_cont.append(sold)
                logback = False
                # s_cont.append(sold)
                try:
                    self._extras_dl()
                    bal.click(); sleep(2)
                except all_element_exceptions:
                    print('...skipping')
                if isinstance(mailer.dig_it(s_cont[0], s_cont[0]), float):
                    print('...prev balance: {}'.format(mailer.dig_it(s_cont[0], s_cont[0])))
                while t >= 0:
                    mins, secs = divmod(t, 60)
                    timeformat = '{:02d}:{:02d}'.format(mins, secs)
                    print('...clicking in', timeformat, end='\r'); sleep(1)
                    t -= 1
                print('')
                print('...now clicking')
                bal.click(); sleep(3)
                all_els = self.find_elements_by_xpath('//*[@id]')
                my_str = ''.join(i.text for e, i in enumerate(all_els) if e == 0)
                if ''.join(i for n, i in enumerate(my_str.split()) if n == 92) == '1138725001':
                    if ''.join(i for n, i in enumerate(my_str.split()) if n == 89) == '':
                        sold1 = ''.join(i for n, i in enumerate(my_str.split()) if n == 86)
                    elif ''.join(i for n, i in enumerate(my_str.split()) if n == 86) == '':
                        sold1 = ''.join(i for n, i in enumerate(my_str.split()) if n == 87)
                    elif ''.join(i for n, i in enumerate(my_str.split()) if n == 87) == '':
                        sold1 = ''.join(i for n, i in enumerate(my_str.split()) if n == 88)
                    else:
                        sold1 = ''.join(i for n, i in enumerate(my_str.split()) if n == 89)
                else:
                    sold1 = ''.join(i for n, i in enumerate(my_str.split()) if n == 92)
                print('')
                try:
                    sleep(0.5)
                    if isinstance(mailer.dig_it(sold1.text, s_cont[0]), float):
                        print('...new balance: {0}'.format(mailer.dig_it(sold1.text, s_cont[0])))
                except ValueError:
                    sleep(1)
                    if isinstance(mailer.dig_it(sold1, s_cont[0]), float):
                        print('...new balance2: {0}'.format(mailer.dig_it(sold1, s_cont[0])))
                try:
                    print('1`st try')
                    if mailer.dig_it(sold1.text, s_cont[0]) - mailer.dig_it(s_cont[0], s_cont[0]) != 0:
                        if sold1 == '':
                            print('reinitiate sold')
                        else:
                            if isinstance(mailer.dig_it(sold1.text, s_cont[0]), float):
                                letter._subject = dict_data['d_name'] + ' ' + mailer.SUBJ + \
                                    ' {0:2d}:{1:2d}:{2:2d}'.format(datetime.now().time().hour, datetime.now().time().minute, datetime.now().time().second)
                                letter.add_to_text_body(
                                    'You`r receiving this mail because of a bank account event.\n\n \
                                    Bank name: {0}\nTransaction details: {1}\n\nMozaik Consulting\nfinancial department\n\n{2}'.format(
                                        dict_data['d_name'], round(mailer.dig_it(sold1.text, s_cont[0]) - mailer.dig_it(s_cont[0], s_cont[0]), 2), datetime.now().time()))
                                letter.send(mailer.S_NAME, mailer.P_NUM, mailer.LOG_U, mailer.PAS, mailer.SEC)
                                print('notification sent, diff: {0}'.format(mailer.dig_it(sold1.text, s_cont[0]) - mailer.dig_it(s_cont[0], s_cont[0])))
                    else:
                        if isinstance(mailer.dig_it(sold1.text, s_cont[0]), float):
                            print('...balance not changed, diff: {0}'.format(mailer.dig_it(sold1.text, s_cont[0]) - mailer.dig_it(s_cont[0], s_cont[0])))
                except (ValueError, TypeError):
                    print('2`nd try')
                    if mailer.dig_it(sold1, s_cont[0]) - mailer.dig_it(s_cont[0], s_cont[0]) != 0:
                        if isinstance(mailer.dig_it(sold1, s_cont[0]), float):
                            letter._subject = dict_data['d_name'] + ' ' + mailer.SUBJ + \
                                ' {0:2d}:{1:2d}:{2:2d}'.format(datetime.now().time().hour, datetime.now().time().minute, datetime.now().time().second)
                            letter.add_to_text_body(
                                'You`r receiving this mail because of a bank account event.\n\n \
                                Bank name: {0}\nTransaction details: {1}\n\nMozaik Consulting\nfinancial department\n\n{2}'.format(
                                    dict_data['d_name'], round(mailer.dig_it(sold1, s_cont[0]) - mailer.dig_it(s_cont[0], s_cont[0]), 2), datetime.now().time()))
                            letter.send(mailer.S_NAME, mailer.P_NUM, mailer.LOG_U, mailer.PAS, mailer.SEC)
                            print('...notification sent, diff: {0}'.format(mailer.dig_it(sold1, s_cont[0]) - mailer.dig_it(s_cont[0], s_cont[0])))
                    else:
                        if isinstance(mailer.dig_it(sold1, s_cont[0]), float):
                            print('...balance not changed, diff: {0}'.format(mailer.dig_it(sold1, s_cont[0]) - mailer.dig_it(s_cont[0], s_cont[0])))
                print('...clicked {0} times'.format(c))
                c += 1
            except all_element_exceptions:
                print('...element lost %s times, waiting to return' % (err))
                if err > 1:
                    logback = True
                try:
                    bal = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_element_by_id(dict_data['uni_refresh']))  # browser.find_element_by_id(data_dict[to_refresh])
                    # print(bal.get_attribute('id'))
                except safety_timeout_exc:
                        self.bank_login()
                        logback = True
                err += 1
