'''
Created on Jul 9, 2019

@author: levente.marton
'''

from time import sleep
from collections import deque
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.support import ui as sui
from selenium.common.exceptions import NoSuchElementException, ElementClickInterceptedException
from selenium.common.exceptions import StaleElementReferenceException, TimeoutException, WebDriverException
from datetime import datetime
from ._remotebank import RemoteBank
from . import mailer
# import mailer
import os
import logging

no_element_exceptions = (NoSuchElementException,
                         ElementClickInterceptedException,
                         WebDriverException)
all_element_exceptions = (NoSuchElementException,
                          ElementClickInterceptedException,
                          StaleElementReferenceException,
                          ValueError, WebDriverException)
safety_timeout_exc = (StaleElementReferenceException, TimeoutException)

letter = mailer.mailer_details(mail_to=mailer.TO, mail_from=mailer.FR_ADDR, mail_subj=mailer.SUBJ)

dict_data = {'url': 'https://www.brdoffice.ro/smartoffice/_mcologon?...OASLogon%2ELanguage=RO',
             'el_us': 'OASLogon.User',
             'el_pw': 'OASLogon.PIN',
             'login': '31300126',
             'refresh': 'pmi_1_123',
             'd_name': 'BRD'
             }

class Bank(RemoteBank):
    '''
    classdocs
    '''
    def __init__(self):
        '''
        Constructor
        '''
        super().__init__()

    def bank_login(self, passw=None):
        self.switch_to.window(self.window_handles[0])
        # print('...switching to tab %s' % (tab + 1))
        self.get(dict_data['url'])
        print('...bank url is %s' % (dict_data['url'])); sleep(1)
        user = self.find_element_by_id(dict_data['el_us'])
        passv = self.find_element_by_id(dict_data['el_pw'])
        try:
            close_ad = self.find_element_by_id('splash-45555-close-button')
            close_ad.click()
        # except no_element_exceptions as exc:
        #     print(str(exc))
        finally:
            user.send_keys(dict_data['login'])
            passw = input('...token pass here')
            passv.send_keys(passw)
            passv.send_keys(Keys.RETURN)
        rap = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element_by_id('pmi_1'))
        rap.click(); sleep(5)

    def _extras_dl(self):
        print('verifying statements')
        with open(self.statement_folder) as log_file:
            if len(os.listdir('extrase')) < 1:
                print('folder is empty')
            else:
                # for att in filter(lambda files: files.endswith('.pdf'), os.listdir('extrase')):
                pass
            lines = log_file.readlines()
            if len(lines) < 1:
                print('file is empty')
            else:
                print('files were found', lines[-1][:10])
            if datetime.now().hour > 17 and lines[-1][:10] != str(datetime.now().date()):
                try:
                    extr = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_element_by_xpath('//*[@id="idListUngrouped"]/tbody/tr[4]/td[1]/a'))
                    extr.click(); sleep(1)
                    extr_dl = self.find_element_by_id('linkpdf')
                    extr_dl.click()
                finally:
                    print('extras_dl performed'); sleep(0.5)
                print('statement downloaded')
                logging.info('date logged')
            else:
                print('skipping statement')
        sleep(2)

    def refresh(self):
        c = 1
        err = 1
        bal = self.find_element_by_id(dict_data['refresh'])
        print(bal.get_attribute('id'))
        sold_cont = deque(maxlen=2)
        logback = False
        while True:
            # s_cont = []
            try:
                t = 210; sleep(3)
                print(dict_data['d_name'])
                sold = self.find_element_by_xpath('//*[@id="idListUngrouped"]/tbody/tr[4]/td[6]')
                # s_cont.append(sold.text)
                if logback is False or len(sold_cont) < 2:
                    sold_cont.appendleft(sold.text)
                logback = False
                try:
                    self._extras_dl()
                    bal.click(); sleep(2)
                except all_element_exceptions:
                    print('...skipping')
                # if isinstance(mailer.dig_it(s_cont[0]), float):
                if isinstance(mailer.dig_it(sold_cont[0], sold_cont[0]), float):
                    print('...prev balance: {}'.format(mailer.dig_it(sold_cont[0], sold_cont[0])))
                while t >= 0:
                    mins, secs = divmod(t, 60)
                    timeformat = '{:02d}:{:02d}'.format(mins, secs)
                    print('...clicking in', timeformat, end='\r'); sleep(1)
                    t -= 1
                print('')
                print('...now clicking')
                bal.click(); sleep(3)
                sold1 = self.find_element_by_xpath('//*[@id="idListUngrouped"]/tbody/tr[4]/td[6]')
                print('')
                try:
                    sleep(0.5)
                    if isinstance(mailer.dig_it(sold1.text, sold_cont[0]), float):
                        print('...new balance: {0}'.format(mailer.dig_it(sold1.text, sold_cont[0])))
                except ValueError:
                    sleep(1)
                    try:
                        if isinstance(mailer.dig_it(sold1, sold_cont[0]), float):
                            print('...new balance2: {0}'.format(mailer.dig_it(sold1, sold_cont[0])))
                    except TypeError:
                        pass
                try:
                    print('1`st try')
                    if mailer.dig_it(sold1.text, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0]) != 0:
                        if sold1 == '':
                            print('reinitiate sold')
                        else:
                            if isinstance(mailer.dig_it(sold1.text, sold_cont[0]), float):
                                letter._subject = dict_data['d_name'] + ' ' + mailer.SUBJ + \
                                    ' {0:2d}:{1:2d}:{2:2d}'.format(datetime.now().time().hour, datetime.now().time().minute, datetime.now().time().second)
                                letter.add_to_text_body(
                                    'You`r receiving this mail because of a bank account event.\n\n \
                                    Bank name: {0}\nTransaction details: {1}\n\nMozaik Consulting\nfinancial department\n\n{2}'.format(
                                        dict_data['d_name'], round(mailer.dig_it(sold1.text, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0]), 2), datetime.now().time()))
                                letter.send(mailer.S_NAME, mailer.P_NUM, mailer.LOG_U, mailer.PAS, mailer.SEC)
                                print('notification sent, diff: {0}'.format(mailer.dig_it(sold1.text, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0])))
                    else:
                        if isinstance(mailer.dig_it(sold1.text, sold_cont[0]), float):
                            print('...balance not changed, diff: {0}'.format(mailer.dig_it(sold1.text, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0])))
                except (ValueError, TypeError):
                    print('2`nd try')
                    try:
                        if mailer.dig_it(sold1, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0]) != 0:
                            if isinstance(mailer.dig_it(sold1, sold_cont[0]), float):
                                letter._subject = dict_data['d_name'] + ' ' + mailer.SUBJ + \
                                    ' {0:2d}:{1:2d}:{2:2d}'.format(datetime.now().time().hour, datetime.now().time().minute, datetime.now().time().second)
                                letter.add_to_text_body(
                                    'You`r receiving this mail because of a bank account event.\n\n \
                                    Bank name: {0}\nTransaction details: {1}\n\nMozaik Consulting\nfinancial department\n\n{2}'.format(
                                        dict_data['d_name'], round(mailer.dig_it(sold1, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0]), 2), datetime.now().time()))
                                letter.send(mailer.S_NAME, mailer.P_NUM, mailer.LOG_U, mailer.PAS, mailer.SEC)
                                print('...notification sent, diff: {0}'.format(mailer.dig_it(sold1, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0])))
                        else:
                            if isinstance(mailer.dig_it(sold1, sold_cont[0]), float):
                                print('...balance not changed, diff: {0}'.format(mailer.dig_it(sold1, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0])))
                    except TypeError:
                        pass
                print('...clicked {0} times'.format(c))
                c += 1
            except all_element_exceptions:
                print('...element lost %s times, waiting to return' % (err))
                if err > 1:
                    logback = True
                try:
                    bal = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_element_by_id(dict_data['refresh']))
                except safety_timeout_exc:
                    self.bank_login()
                    logback = True
                # bal.click()  # browser.find_element_by_id(data_dict[to_refresh])
                err += 1
