'''
Created on Jul 23, 2019

@author: levente.marton
'''

from time import sleep
from collections import deque
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.support import ui as sui
from selenium.common.exceptions import NoSuchElementException, ElementClickInterceptedException
from selenium.common.exceptions import StaleElementReferenceException, TimeoutException, WebDriverException
from datetime import datetime
from ._remotebank import RemoteBank
from . import mailer
# import mailer
import os
import logging

no_element_exceptions = (NoSuchElementException,
                         ElementClickInterceptedException,
                         WebDriverException)
all_element_exceptions = (NoSuchElementException,
                          ElementClickInterceptedException,
                          StaleElementReferenceException,
                          ValueError, WebDriverException)
safety_timeout_exc = (StaleElementReferenceException, TimeoutException)

letter = mailer.mailer_details(mail_to=mailer.TO, mail_from=mailer.FR_ADDR, mail_subj=mailer.SUBJ)

dict_data = {'url': 'https://ib.btrl.ro/BT24/bfo/channel/web/loginframe.jsp?locale=RO',
             'el_us': '$$LoginId$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest',
             'el_pw': '$$AuthToken$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest',
             'login': 'N63584PA',
             'refresh': 'balancerefresh_ron_link',
             'd_name': 'BT'
             }

class Bank(RemoteBank):
    '''
    classdocs
    '''

    def __init__(self):
        '''
        Constructor
        '''
        super().__init__()

    def bank_login(self, passw=None):
        self.switch_to.window(self.window_handles[0])
        self.get(dict_data['url'])
        print('...bank url is %s' % (dict_data['url'])); sleep(1)
        try:
            bt_iframe = self.find_elements_by_tag_name('iframe')[0]
            self.switch_to.frame(bt_iframe); sleep(2)
            user = self.find_element_by_id(dict_data['el_us'])
            user.send_keys(dict_data['login'])
            passv = self.find_element_by_id(dict_data['el_pw'])
            passv.send_keys(input('...token pass here'))
            passv.send_keys(Keys.RETURN)
        except NoSuchElementException:
            user = self.find_element_by_id(dict_data['el_us'])
            user.send_keys(dict_data['login'])
            passv = self.find_element_by_id(dict_data['el_pw'])
            passv.send_keys(input('...token pass here'))
            passv.send_keys(Keys.RETURN)

    def _extras_dl(self):
        print('verifying statements'); sleep(1)
        with open(self.statement_folder) as log_file:
            if len(os.listdir('extrase')) < 1:
                print('folder is empty')
            else:
                pass
            lines = log_file.readlines()
            if len(lines) < 1:
                print('file is empty')
            else:
                print('files were found', lines[-1][:10])
            if datetime.now().hour > 17 and lines[-1][:10] != str(datetime.now().date()):
                sleep(2)
                extr = sui.WebDriverWait(self, 5).until(lambda browser: browser.find_elements_by_id('26603_link')[0])  # browser.find_element_by_id('26603_link')
                extr.click(); sleep(1)
                self.switch_to.default_content()
                page_iframe = self.find_elements_by_tag_name('iframe')[1]
                self.switch_to.frame(page_iframe); sleep(0.5)
                extr_account = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_elements_by_class_name('linkLabelVisited')[1])
                sleep(0.5)
                extr_account.click(); sleep(10)
                extr_pdf = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element_by_xpath('.//*[@id="export2"]'))  # './/*[@id="download_1"]/span'
                extr_pdf.click(); sleep(0.5)
                extr_dl = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element_by_xpath('//*[@id="export"]/span[2]'))
                extr_dl.click(); sleep(1)
                self.switch_to.default_content()
                _home = self.find_elements_by_class_name('image_close')[1]  # //*[@id="page1542644222340693_close_img"]
                _home.click(); sleep(0.5)
                print('statement downloaded')
                logging.info('date logged')
            else:
                print('skipping statement')
        sleep(2)

    def refresh(self):
        c = 1
        err = 1
        bt_iframe2 = self.find_elements_by_tag_name('iframe')[0]
        self.switch_to.frame(bt_iframe2)
        bal = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_element_by_id(dict_data['refresh']))
        print(bal.get_attribute('id'))
        sold_cont = deque(maxlen=2)
        logback = False
        while True:
            try:
                t = 210; sleep(3)
                print(dict_data['d_name'])
                sold = self.find_element_by_xpath('//*[@id="ronBalanceOnline"]')
                if logback is False or len(sold_cont) < 2:
                    sold_cont.appendleft(sold.text)
                logback = False
                try:
                    self._extras_dl()
                    bal.click(); sleep(2)
                except all_element_exceptions:
                    print('...skipping')
                if isinstance(mailer.dig_it(sold_cont[0], sold_cont[0]), float):
                    print('...prev balance: {}'.format(mailer.dig_it(sold_cont[0], sold_cont[0])))
                else:
                    bal.click()
                    sold = self.find_element_by_xpath('//*[@id="ronBalanceOnline"]')
                    sold_cont.appendleft(sold.text)
                while t >= 0:
                    mins, secs = divmod(t, 60)
                    timeformat = '{:02d}:{:02d}'.format(mins, secs)
                    print('...clicking in', timeformat, end='\r'); sleep(1)
                    t -= 1
                print('')
                print('...now clicking')
                bal.click(); sleep(3)
                sold1 = self.find_element_by_xpath('//*[@id="ronBalanceOnline"]')
                print('')
                try:
                    sleep(0.5)
                    if isinstance(mailer.dig_it(sold1.text, sold_cont[0]), float):
                        print('...new balance: {0}'.format(mailer.dig_it(sold1.text, sold_cont[0])))
                except ValueError:
                    sleep(1)
                    try:
                        if isinstance(mailer.dig_it(sold1, sold_cont[0]), float):
                            print('...new balance2: {0}'.format(mailer.dig_it(sold1, sold_cont[0])))
                    except TypeError:
                        pass
                try:
                    print('1`st try')
                    if mailer.dig_it(sold1.text, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0]) != 0:
                        if sold1 == '':
                            print('reinitiate sold')
                        else:
                            if isinstance(mailer.dig_it(sold1.text, sold_cont[0]), float):
                                letter._subject = dict_data['d_name'] + ' ' + mailer.SUBJ + \
                                    ' {0:2d}:{1:2d}:{2:2d}'.format(datetime.now().time().hour, datetime.now().time().minute, datetime.now().time().second)
                                letter.add_to_text_body(
                                    'You`r receiving this mail because of a bank account event.\n\n \
                                    Bank name: {0}\nTransaction details: {1}\n\nMozaik Consulting\nfinancial department\n\n{2}'.format(
                                        dict_data['d_name'], round(mailer.dig_it(sold1.text, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0]), 2), datetime.now().time()))
                                letter.send(mailer.S_NAME, mailer.P_NUM, mailer.LOG_U, mailer.PAS, mailer.SEC)
                                print('notification sent, diff: {0}'.format(mailer.dig_it(sold1.text, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0])))
                    else:
                        if isinstance(mailer.dig_it(sold1.text, sold_cont[0]), float):
                            print('...balance not changed, diff: {0}'.format(mailer.dig_it(sold1.text, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0])))
                except (ValueError, TypeError):
                    print('2`nd try')
                    try:
                        if mailer.dig_it(sold1, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0]) != 0:
                            if isinstance(mailer.dig_it(sold1, sold_cont[0]), float):
                                letter._subject = dict_data['d_name'] + ' ' + mailer.SUBJ + \
                                    ' {0:2d}:{1:2d}:{2:2d}'.format(datetime.now().time().hour, datetime.now().time().minute, datetime.now().time().second)
                                letter.add_to_text_body(
                                    'You`r receiving this mail because of a bank account event.\n\n \
                                    Bank name: {0}\nTransaction details: {1}\n\nMozaik Consulting\nfinancial department\n\n{2}'.format(
                                        dict_data['d_name'], round(mailer.dig_it(sold1, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0]), 2), datetime.now().time()))
                                letter.send(mailer.S_NAME, mailer.P_NUM, mailer.LOG_U, mailer.PAS, mailer.SEC)
                                print('...notification sent, diff: {0}'.format(mailer.dig_it(sold1, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0])))
                        else:
                            if isinstance(mailer.dig_it(sold1, sold_cont[0]), float):
                                print('...balance not changed, diff: {0}'.format(mailer.dig_it(sold1, sold_cont[0]) - mailer.dig_it(sold_cont[0], sold_cont[0])))
                    except TypeError:
                        pass
                print('...clicked {0} times'.format(c))
                c += 1
            except all_element_exceptions:
                print('...element lost %s times, waiting to return' % (err))
                if err > 1:
                    logback = True
                try:
                    bt_iframe = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_elements_by_tag_name('iframe')[0])  # browser.find_elements_by_tag_name('iframe')[0]
                    self.switch_to.frame(bt_iframe)
                    bal = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_element_by_id(dict_data['refresh']))
                except:
                    try:
                        bal = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_element_by_id(dict_data['refresh']))
                    except safety_timeout_exc:
                        self.bank_login()
                        logback = True
                err += 1
