from datetime import datetime
from time import sleep
from selenium import webdriver
from selenium.webdriver import ChromeOptions
from selenium.webdriver.common.keys import Keys
from selenium.common.exceptions import NoSuchElementException, ElementClickInterceptedException
from selenium.common.exceptions import StaleElementReferenceException, TimeoutException
import mailer
import selenium.webdriver.support.ui as sui
import os
import logging


class RemoteBank(webdriver.Chrome):

    cls_chrome_options = ChromeOptions()
    cls_chrome_options.add_argument('--disable-infobars')
#     cls_chrome_options.add_experimental_option('excludeSwitches', ['enable-automation'])
#     cls_chrome_options.add_experimental_option('useAutomationExtension', False)
    cls_chrome_options.add_argument('--disable-dev-shm-usage')
    cls_chrome_options.add_argument('--no-sandbox')
    cls_chrome_options.add_argument('--disable-gpu')
    path_to_cache = 'not set'
    statement_folder = 'extrase/'
    # cls_chrome_options.add_argument('user-data-dir=_bt_')
    def __init__(self, chrome_options=cls_chrome_options):
        self.chrome_options = chrome_options
        super().__init__(chrome_options=self.chrome_options)

    @classmethod
    def set_user_data_dir(cls, path_to_cache):
        cls.cls_chrome_options.add_argument(path_to_cache)
        cls.path_to_cache = path_to_cache

    @classmethod
    def user_data_dir(cls):
        return cls.path_to_cache

    @classmethod
    def set_statement_filename(cls, filename):
        cls.statement_folder = cls.statement_folder + filename

    @classmethod
    def statement_filename(cls):
        return cls.statement_folder


    @classmethod
    def set_log(cls):
        logging.basicConfig(filename=cls.statement_folder, format='%(asctime)s %(message)s', datefmt='%Y-%m-%d', level=logging.INFO)
        cls.file_for_log = cls.statement_folder

#     @classmethod
#     def log_file_name(cls):
#         return cls.file_for_log

    def tab_load(self, nr_tabs):
        nr_tabs -= 1
        self.get('https://duckduckgo.com/?q=python&t=hf&ia=about')
        print('loading %s tabs' % (nr_tabs + 1))
        first_result = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element_by_class_name('body--serp'))
        first_link = first_result.find_element_by_tag_name('a')
        main_window = self.current_window_handle
        self.switch_to.window(main_window)
        i = 0
        while i < nr_tabs:
            first_link.send_keys(Keys.CONTROL + Keys.RETURN)
            i += 1
            sleep(1)
        self.switch_to.window(self.window_handles[0])
        sleep(2)
